/**
 * @file tkl_bluetooth.c
 * @brief this file was auto-generated by tuyaos v&v tools, developer can add implements between BEGIN and END
 * 
 * @warning: changes between user 'BEGIN' and 'END' will be keeped when run tuyaos v&v tools
 *           changes in other place will be overwrited and lost
 *
 * @copyright Copyright 2020-2021 Tuya Inc. All Rights Reserved.
 * 
 */

// --- BEGIN: user defines and implements ---
#include <stdio.h>
#include "tkl_bluetooth.h"
#include "tuya_error_code.h"
#include <assert.h>
#include "pthread.h"


#include <linux/fs.h>
//#include <linux/kernel.h>
//#include <linux/module.h>
#include <linux/string.h>

//#include "atbm_hal.h"

// #include "services/gap/ble_svc_gap.h"
// #include "services/dis/ble_svc_dis.h"
// #include "services/gatt/ble_svc_gatt.h"
// #include "host/ble_gatt.h"
// #include "host/ble_att.h"
// #include "host/ble_hs.h"
// #include "host/util/util.h"
// #include "nimble/ble_hci_trans.h"
// //#include "atbm_os_mutex.h"
// #include "atbm_os_api.h"
// #include "host/ble_gap.h"
#include "ble_smart_cfg.h"
// #include "atbm_os_timer.h"
// #include "atbm_os_msgQ.h"


// #define BLE_USER_DATA_SVC_UUID16			0x181C
// #define BLE_ATBM_SMART_DATA					0x2A8A
// #define BLE_ATBM_SMART_NOTIFY				0x2A90

// #define BLE_ATBM_GAP_SVR					0xBBB0
// #define BLE_ATBM_GAP_SVR1					0xBBB1


// #define BLE_GATT_THOUGHPUT_TEST				0


// static const char *device_name = "TUYA_";
// static const char *ble_version = "nimble4.2";
// static const char *firmware_info = "cronus_1.0";
// static const char *software_info = "V1.0.0";
// static const char* wifi_conn_ok ="ok";
// static const char* wifi_conn_no ="no";
// static const char* wifi_conn_wait ="wt";

// struct ble_smart_cfg_t  ble_smart_info;

// static uint8_t blesmt_addr_type=0;
// uint16_t blesmt_notify_handle;
// uint8_t atbm_ble_status=0;

// int smart_cfg_start = 0;
// static struct ble_npl_sem hci_smt_sem;
// static uint16_t smt_conn_handle;
// pAtbm_thread_t ble_smt_thread = NULL;
// extern uint16_t ble_svc_gatt_changed_val_handle;
// extern bool atbm_ble_is_quit;

// uint16_t ble_conn_handle;

typedef signed char s8;

typedef unsigned char u8;

typedef signed short s16;

typedef unsigned short u16;

typedef signed int s32;

typedef unsigned int u32;

typedef signed long long s64;

typedef unsigned long long u64;


#define MAX_SYNC_EVENT_BUFFER_LEN 	512

#define ATBM_SMT_STATUS_STOP		1
#define ATBM_SMT_STATUS_MSG			2

int cfg_done_connected;

char connect_ap[64];

// TKL_BLE_GAP_EVT_FUNC_CB g_gap_evt_call = NULL;
// TKL_BLE_GATT_EVT_FUNC_CB g_gatt_evt_call = NULL;

struct status_async
{
	u8 type; /* 0: connect msg, 1: driver msg, 2:scan complete, 3:wakeup host reason, 4:disconnect reason, 5:connect fail reason, 6:customer event*/
	u8 driver_mode; /* TYPE1 0: rmmod, 1: insmod; TYPE3\4\5 reason */
	u8 list_empty;
	u8 event_buffer[MAX_SYNC_EVENT_BUFFER_LEN];
};


struct at_cmd_direct_info
{
	u32 len;
	u8 cmd[1500];
};

static struct wsm_ble_smt_ind ble_smt;
static char gCmdStr[512];

char* cmd_system(const char* command,char * buf,int buff_len)
{
    char* result = NULL;
    FILE *fpRead;
    fpRead = popen(command, "r");
	if(buf && (buff_len > 1)){
  //  char buf[1024];
	    memset(buf,'\0',sizeof(buf));
	    while(fgets(buf,buff_len-1,fpRead)!=NULL)
	    { 
			result=buf;
	    }
	}
    if(fpRead != NULL)
        pclose(fpRead);

    return result;

}

int smt_check_wpa_status()
{
	printf("smt check wpa status!\n");
#if 0
	int result = 0;
	
	int wpa_success = 0;
	char tmpstring[50];
	char* wpa_state = "wpa_state=COMPLETED";

	result = system("wpa_cli status | tee /tmp/wpa_status.txt");
	
		
	fprintf(stdout, "check_wap_status result:%d\n", result);

	FILE* status_file = fopen("/tmp/wpa_status.txt", "r");
	if (status_file == NULL) {
		printf("Error no status file\n");
		exit(-1);
	}

	printf("check wpa for string %s\n", wpa_state);

	while (fscanf(status_file, "%s", tmpstring) == 1) {
		// printf("tmpstring %s\n", tmpstring);
		if (strstr(tmpstring, wpa_state) != 0) {//if match found
			{
				wpa_success = 1;
				//wifi_connected_completed = 1;
				break;
			}
		}
	}

	fclose(status_file);
#else
	int wpa_success = 0;
	char buff[32];
	cmd_system("iwpriv wlan0 common get_conn_state > /tmp/wpa_status.txt",NULL,0);
	cmd_system("cat /tmp/wpa_status.txt | grep wifi",buff,32); 
	sscanf(buff,"wifi_status=%d",&wpa_success);
#endif

	printf("wpa_success %d\n", wpa_success);
	return wpa_success;

}

int get_wifi_wpa_status()
{
	fprintf(stdout, "get_wifi_wpa_status cfg_done_connected:%d\n" ,cfg_done_connected);
	return  cfg_done_connected;
}

void connect_wifi_ap(u8* ssid, u8 ssidLen, u8* pwd, u8 pwdLen)
{
	u8 ssidStr[33] = { 0 };
	u8 pwdStr[65] = { 0 };
	int sret, i;
	int conn_ap_len;
	if (ssidLen > 32 || pwdLen > 64) {
		fprintf(stdout, "ssidLen(%d) pwdLen(%d) error!\n", ssidLen, pwdLen);
		return;
	}

	memcpy(ssidStr, ssid, ssidLen);
	memcpy(pwdStr, pwd, pwdLen);

#if 1

	conn_ap_len = strlen(connect_ap);
	if(conn_ap_len){
		if(pwdLen)
			sprintf(gCmdStr, "%s %s %s",connect_ap,ssid,pwd);
		else
			sprintf(gCmdStr, "%s %s",connect_ap,ssid);
	}else{
		if(pwdLen)
			sprintf(gCmdStr, "/tmp/connect_ap.sh %s %s",ssid,pwd);
		else
			sprintf(gCmdStr, "/tmp/connect_ap.sh %s",ssid);
	}
	printf("start CMD:%s \n",gCmdStr);
	system(gCmdStr);
//	cmd_system(gCmdStr,NULL,0);
	
#else

	sprintf(gCmdStr, "ifconfig wlan0 down");
	sret = system(gCmdStr);
	usleep(100000);

	sprintf(gCmdStr, "killall wpa_supplicant");
	sret = system(gCmdStr);
	usleep(100000);

	sprintf(gCmdStr, "wpa_supplicant -D nl80211 -i wlan0 -c /usr/wpa_cfg/wpa_supplicant.conf -B");
	sret = system(gCmdStr);
	usleep(100000);

	sprintf(gCmdStr, "ifconfig wlan0 up");
	sret = system(gCmdStr);
	usleep(100000);

	sprintf(gCmdStr, "wpa_cli -i wlan0 remove_network 0");
	sret = system(gCmdStr);
	usleep(100000);

	sprintf(gCmdStr, "wpa_cli -i wlan0 ap_scan 1");
	sret = system(gCmdStr);
	usleep(100000);

	sprintf(gCmdStr, "wpa_cli -i wlan0 add_network");
	sret = system(gCmdStr);
	usleep(1000000);

	sprintf(gCmdStr, "wpa_cli -i wlan0 set_network 0 ssid '\"%s\"'", ssidStr);
	sret = system(gCmdStr);
	fprintf(stdout, "%s\n", gCmdStr);

	if (pwdLen > 0) {
		sprintf(gCmdStr, "wpa_cli -i wlan0 set_network 0 psk '\"%s\"'", pwdStr);
		sret = system(gCmdStr);
		fprintf(stdout, "%s\n", gCmdStr);
	}
	else {
		sprintf(gCmdStr, "wpa_cli -i wlan0 set_network 0 key_mgmt NONE");
		sret = system(gCmdStr);
		fprintf(stdout, "%s\n", gCmdStr);
		for (i = 0; i < 4; i++) {
			sprintf(gCmdStr, "wpa_cli -i wlan0 set_network 0 wep_key%i \"\"", i);
			sret = system(gCmdStr);
		}
	}

	sprintf(gCmdStr, "wpa_cli -i wlan0 set_network 0 scan_ssid 1", ssidStr);
	sret = system(gCmdStr);

	sprintf(gCmdStr, "wpa_cli -i wlan0 select_network 0");
	sret = system(gCmdStr);
#endif
}

int smt_demo_end_indicate(u8* event_buffer)
{
	int ret = -1;
	int result = 0;
	int i = 0;
	time_t broadcast_suc = 0;
	time_t broadcast_suc_end = 0;
	char buff[32];


	fprintf(stdout, "ble smart config end...\n");
	//atbm_smt_status = 0;
	cfg_done_connected = 0;


	do {
			memcpy(&ble_smt, event_buffer, sizeof(struct wsm_ble_smt_ind));

			if (ble_smt.status == BLE_SMART_CFG_SSID_PWD_TRANS_END) {

				broadcast_suc = time((time_t*)NULL);
				fprintf(stdout, "ble smart config ssid pwd trans Done(0x%X) ssid %s pwd %s\n", ble_smt.status, ble_smt.ssid, ble_smt.pwd);

				//change_driver_to_wifi(driverName_ble, driverName_wifi);
				connect_wifi_ap(ble_smt.ssid, ble_smt.ssid_len, ble_smt.pwd, ble_smt.pwd_len);
				
				cmd_system("iwpriv wlan0 common get_conn_state > /tmp/wpa_status.txt",NULL,0);
				cmd_system("cat /tmp/wpa_status.txt | grep wifi",buff,32); 
				sscanf(buff,"wifi_status=%d",&result);
				
				fprintf(stdout, "check_wap_status result:%d pwd:%s len:%d\n", result, ble_smt.pwd, ble_smt.pwd_len);

				goto config_err;
			}
			else if (ble_smt.status == BLE_SMART_CFG_STATUS_END) {

			//	result = system("wpa_cli status | tee /tmp/wpa_status.txt");
				cmd_system("iwpriv wlan0 common get_conn_state > /tmp/wpa_status.txt",NULL,0);
				cmd_system("cat /tmp/wpa_status.txt | grep wifi",buff,32); 
				sscanf(buff,"wifi_status=%d",&result);
				fprintf(stdout, " wap_status:%d\n", result);
				//fprintf(stdout,"ble smart config Done(0x%X)\n", ble_smt.status);
				//	goto config_err;
			}
			else if (ble_smt.status == BLE_SMART_CFG_STATUS_SUCESS) {
				//change_driver_to_wifi(driverName_ble, driverName_wifi);
				//connect_wifi_ap(ble_smt.ssid, ble_smt.ssid_len, ble_smt.pwd, ble_smt.pwd_len);
				fprintf(stdout, "ble smart config Done(0x%X)\n", ble_smt.status);
				goto config_err;

			}
			else {
				fprintf(stdout, "ble smart config err(0x%X)\n", ble_smt.status);
				//change_driver_to_wifi(driverName_ble, driverName_wifi);
				//goto config_err;
			}
	} while (0);

config_err:

	while (i < 10) {
		broadcast_suc_end = time((time_t*)NULL);
		cfg_done_connected = smt_check_wpa_status();
		if (((broadcast_suc_end - broadcast_suc) > 10) || (cfg_done_connected == 1)) {   //20 seconds timeout or recievd ack.
			fprintf(stdout, "connect_wifi_ap broadcast_suc:%d end:%d, cfg_done_connected:%d\n", broadcast_suc, broadcast_suc_end, cfg_done_connected);
			break;
		}
		sleep(1);
		i++;
	}

	if (cfg_done_connected) {
		fprintf(stdout, "exit ble_smt process wifi connected \n");
	}
	else {
		fprintf(stdout, "exit ble_smt process wifi failed to connect \n");
	}

	return 0;
}

// --- END: user defines and implements ---

void *ble_stack_proc(void *param)
{
	// pthread_detch(pthread_slef());

	setup_ble_init_event();
	
	lib_ble_main();
	
	return NULL;
}

/**
 * @brief   Function for initializing the ble stack
 * @param   role                Indicate the role for ble stack.
 *                              role = 1: ble peripheral    @TKL_BLE_ROLE_SERVER
 *                              role = 2: ble central       @TKL_BLE_ROLE_CLIENT
 * @return  SUCCESS             Initialized successfully.
 *          ERROR
 * */
OPERATE_RET tkl_ble_stack_init(UCHAR_T role)
{
    // --- BEGIN: user implements ---
	printf("init ble stack! rol is %d\n", role);
	int ret = 0;
	
	pthread_t pid;

	ret = pthread_create(&pid, NULL, ble_stack_proc, NULL);
	if(ret != 0){
		printf("create ble stack thread faile!\n");
	}
	
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Function for de-initializing the ble stack features
 * @param   role                 Indicate the role for ble stack.
 *                               role = 1: ble peripheral
 *                               role = 2: ble central
 * @return  SUCCESS             Deinitialized successfully.
 *          ERROR
 * */
OPERATE_RET tkl_ble_stack_deinit(UCHAR_T role)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_stack_deinit\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Function for getting the GATT Link-Support.
 * @param   p_link              return gatt link                 
 * @return  SUCCESS             Support Gatt Link
 *          ERROR               Only Beacon or Mesh Beacon, Not Support Gatt Link.
 * */
OPERATE_RET tkl_ble_stack_gatt_link(USHORT_T *p_link)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_stack_gatt_link\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Register GAP Event Callback
 * @param   TKL_BLE_GAP_EVT_FUNC_CB Refer to @TKL_BLE_GAP_EVT_FUNC_CB
 * @return  SUCCESS         Register successfully.
 *          ERROR
 * */
OPERATE_RET tkl_ble_gap_callback_register(CONST TKL_BLE_GAP_EVT_FUNC_CB gap_evt)
{
    // --- BEGIN: user implements ---
	printf("gap callback register!\n");

	//disable for test
	//ble_svc_gap_init();
	//g_gap_evt_call = gap_evt;
	set_gap_callback(gap_evt);
    return OPRT_OK;
    // --- END: user implements ---
}


/**
 * @brief   Register GATT Event Callback
 * @param   TKL_BLE_GATT_EVT_FUNC_CB Refer to @TKL_BLE_GATT_EVT_FUNC_CB
 * @return  SUCCESS         Register successfully.
 *          ERROR
 * */
OPERATE_RET tkl_ble_gatt_callback_register(CONST TKL_BLE_GATT_EVT_FUNC_CB gatt_evt)
{
    int rc;
	printf("tkl_ble_gatt_callback_register!\n");

	//disable for test
	//ble_smart_gatt_svcs_init();
	//g_gatt_evt_call = gatt_evt;
	set_gatt_callback(gatt_evt);
    // --- BEGIN: user implements ---
    return OPRT_OK;
    // --- END: user implements ---
}

/******************************************************************************************************************************/
/** @brief Define All GAP Interface
 */
/**
 * @brief   Set the local Bluetooth identity address.
 *          The local Bluetooth identity address is the address that identifies this device to other peers.
 *          The address type must be either @ref TKL_BLE_GAP_ADDR_TYPE_PUBLIC or @ref TKL_BLE_GAP_ADDR_TYPE_RANDOM.
 * @param   [in] p_peer_addr:   pointer to local address parameters 
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gap_addr_set(TKL_BLE_GAP_ADDR_T CONST *p_peer_addr)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_addr_set\n");
    return 0;
    // --- END: user implements ---
}

/**
 * @brief   Get the local Bluetooth identity address.
 * @param   [out] p_peer_addr:  pointer to local address
 * @return  SUCCESS             Set Address successfully.
 *          ERROR
 * */
OPERATE_RET tkl_ble_gap_address_get(TKL_BLE_GAP_ADDR_T *p_peer_addr)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_address_get!\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Start advertising
 * @param   [in] p_adv_params : pointer to advertising parameters 
 * @return  SUCCESS
 *  ERROR
 * */ 
OPERATE_RET tkl_ble_gap_adv_start(TKL_BLE_GAP_ADV_PARAMS_T CONST *p_adv_params)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_adv_start!\n");
	gap_adv_start(p_adv_params);
	//disable for test
	// blesmt_advertise();
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Stop advertising
 * @param   VOID
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gap_adv_stop(VOID)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_adv_stop!\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Setting advertising data
 * @param   [in] p_adv:         Data to be used in advertisement packets, and include adv data len
 *          [in] p_scan_rsp:    Data to be used in advertisement respond packets, and include rsp data len
 * @Note    Please Check p_adv and p_scan_rsp, if data->p_data == NULL or data->length == 0, we will not update these values.
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gap_adv_rsp_data_set(TKL_BLE_DATA_T CONST *p_adv, TKL_BLE_DATA_T CONST *p_scan_rsp)
{
    // --- BEGIN: user implements ---

    printf("tkl_ble_gap_adv_rsp_data_set function! data len %d\n", p_adv->length);
	printf("adv data:%s\n", p_adv->p_data);
	printf("scan rsp data len %d\n", p_scan_rsp->length);
	printf("scan rsp data:%s\n", p_scan_rsp->p_data);

	gap_adv_rsp_data_set(p_adv, p_scan_rsp);

	//disable for test
	//blesmt_advertise();
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Update advertising data
 * @param   [in] p_adv: Data    to be used in advertisement packets, and include adv data len
 *          [in] p_scan_rsp:    Data to be used in advertisement respond packets, and include rsp data len
 * @Note    Please Check p_adv and p_scan_rsp, if data->p_data == NULL or data->length == 0, we will not update these values.
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gap_adv_rsp_data_update(TKL_BLE_DATA_T CONST *p_adv, TKL_BLE_DATA_T CONST *p_scan_rsp)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_adv_rsp_data_update\n");

    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Start scanning
 * @param   [in] scan_param:    scan parameters including interval, windows
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gap_scan_start(TKL_BLE_GAP_SCAN_PARAMS_T CONST *p_scan_params)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_scan_start!\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Stop scanning
 * @param   VOID
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gap_scan_stop(VOID)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_scan_stop\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Start connecting one peer
 * @param   [in] p_peer_addr:   include address and address type
 *          [in] p_scan_params: scan parameters
 *          [in] p_conn_params: connection  parameters
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gap_connect(TKL_BLE_GAP_ADDR_T CONST *p_peer_addr, TKL_BLE_GAP_SCAN_PARAMS_T CONST *p_scan_params, TKL_BLE_GAP_CONN_PARAMS_T CONST *p_conn_params)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_connect\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Disconnect from peer
 * @param   [in] conn_handle:   the connection handle
 *          [in] hci_reason:    terminate reason
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gap_disconnect(USHORT_T conn_handle, UCHAR_T hci_reason)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_disconnect\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Start to update connection parameters
 * @param   [in] conn_handle:   connection handle
 *          [in] p_conn_params: connection  parameters
 * @return  SUCCESS
 *          ERROR
 * */
OPERATE_RET tkl_ble_gap_conn_param_update(USHORT_T conn_handle, TKL_BLE_GAP_CONN_PARAMS_T CONST *p_conn_params)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_conn_param_update\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Set the radio's transmit power.
 * @param   [in] role:          0: Advertising Tx Power; 1: Scan Tx Power; 2: Connection Power
 *          [in] tx_power:      tx power:This value will be magnified 10 times. 
 *                              If the tx_power value is -75, the real power is -7.5dB.(or 40 = 4dB)
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gap_tx_power_set(UCHAR_T role, INT_T tx_power)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_tx_power_set\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Get the received signal strength for the last connection event.
 * @param   [in]conn_handle:    connection handle
 * @return  SUCCESS             Successfully read the RSSI.
 *          ERROR               No sample is available.
 * */
OPERATE_RET tkl_ble_gap_rssi_get(USHORT_T conn_handle)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_rssi_get\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Set the GAP Name For Bluetooth
 * @param   [in]p_name:         GAP Name String
 * @return  SUCCESS
 *          ERROR
 * */
OPERATE_RET tkl_ble_gap_name_set(CHAR_T *p_name)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gap_name_set name %s\n", p_name);
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Add Ble Gatt Service
 * @param   [in] p_service: define the ble service
 *
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gatts_service_add(TKL_BLE_GATTS_PARAMS_T *p_service)
{
    // --- BEGIN: user implements ---
	printf("to do tkl_ble_gatts_service_add!\n");
	int j = 0;
	//gatt_svcs_init(p_service);
	
    ble_smart_gatt_svcs_init();

	for(j = 0; j < p_service->p_service[0].char_num; j++){
		if(TKL_BLE_GATT_CHAR_PROP_NOTIFY == p_service->p_service[0].p_char[j].property){
			p_service->p_service[0].p_char[j].handle = 0x2902;
		}else if(TKL_BLE_GATT_CHAR_PROP_WRITE== p_service->p_service[0].p_char[j].property){
			p_service->p_service[0].p_char[j].handle = 0x2901;
		}else if(TKL_BLE_GATT_CHAR_PROP_READ== p_service->p_service[0].p_char[j].property){
			p_service->p_service[0].p_char[j].handle = 0x2903;
		}
	}
	
	return OPRT_OK;
    // --- END: user implements ---
}

OPERATE_RET tkl_ble_gatts_service_change(USHORT_T conn_handle, USHORT_T start_handle, USHORT_T end_handle)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gatts_service_change\n");
    return OPRT_OK;
    // --- END: user implements ---    
}
/**
 * @brief   Set the value of a given attribute. After Config Tuya Read-Char, we can update read-value at any time.
 * @param   [in] conn_handle    Connection handle.
 *          [in] char_handle    Attribute handle.
 *          [in,out] p_value    Attribute value information.
 * @return  SUCCESS
 *          ERROR
 *
 * @note Values other than system attributes can be set at any time, regardless of whether any active connections exist. 
 * */ 
OPERATE_RET tkl_ble_gatts_value_set(USHORT_T conn_handle, USHORT_T char_handle, UCHAR_T *p_data, USHORT_T length)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gatts_value_set\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Get the value of a given attribute.
 * @param   [in] conn_handle    Connection handle. Ignored if the value does not belong to a system attribute.
 * @param   [in] char_handle    Attribute handle.
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gatts_value_get(USHORT_T conn_handle, USHORT_T char_handle, UCHAR_T *p_data, USHORT_T length)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gatts_value_get\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Notify an attribute value.
 * @param   [in] conn_handle    Connection handle.
 * @param   [in] char_handle    Attribute handle.
 *          [in] p_data         Notify Values
 *          [in] length         Value Length
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gatts_value_notify(USHORT_T conn_handle, USHORT_T char_handle, UCHAR_T *p_data, USHORT_T length)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gatts_value_notify!\n");
	int rc;
	rc=gatt_svr_chr_notify(conn_handle, char_handle, p_data, length);
	if(rc != 0)
	{
		printf("gatt_svr_chr_notify error\n");
	}
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Indicate an attribute value.
 * @param   [in] conn_handle    Connection handle.
 * @param   [in] char_handle    Attribute handle.
 *          [in] p_data         Notify Values
 *          [in] length         Value Length
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gatts_value_indicate(USHORT_T conn_handle, USHORT_T char_handle, UCHAR_T *p_data, USHORT_T length)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gatts_value_indicate");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Reply to an ATT_MTU exchange request by sending an Exchange MTU Response to the client.
 * @param   [in] conn_handle    Connection handle.
 *          [in] server_rx_mtu  mtu size.
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gatts_exchange_mtu_reply(USHORT_T conn_handle, USHORT_T server_rx_mtu)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gatts_exchange_mtu_reply");
    return OPRT_OK;
    // --- END: user implements ---
}

/******************************************************************************************************************************/
/** @brief Define All Gatt Client Interface, Refer to current ble gw and ble stack.
 *
 *  Notes: notice the handle will be the one of signed point.
 *  Discovery Operations belongs to GAP Interface, But declear here, because it will be used for the gatt client.
 */
 
/**
 * @brief   [Ble Central] Will Discovery All Service
 * @param   [in] conn_handle    Connection handle.
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gattc_all_service_discovery(USHORT_T conn_handle)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gattc_all_service_discovery\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   [Ble Central] Will Discovery All Characteristic
 * @param   [in] conn_handle    Connection handle.
 *          [in] start_handle   Handle of start
 *          [in] end_handle     Handle of End
 * @return  SUCCESS
 *          ERROR
 * @Note:   For Tuya Service, it may contains more optional service, it is more better to find all Characteristic 
 *          instead of find specific uuid.
 * */  
OPERATE_RET tkl_ble_gattc_all_char_discovery(USHORT_T conn_handle, USHORT_T start_handle, USHORT_T end_handle)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gattc_all_char_discovery\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   [Ble Central] Will Discovery All Descriptor of Characteristic
 * @param   [in] conn_handle    Connection handle.
 * @param   [in] conn_handle    Connection handle.
 *          [in] start_handle   Handle of start
 *          [in] end_handle     Handle of End
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gattc_char_desc_discovery(USHORT_T conn_handle, USHORT_T start_handle, USHORT_T end_handle)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gattc_char_desc_discovery\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   [Ble Central] Write Data without Response
 * @param   [in] conn_handle    Connection handle.
 * @param   [in] char_handle    Attribute handle.
 *          [in] p_data         Write Values
 *          [in] length         Value Length
 * @return  SUCCESS
 *          ERROR
 * */ 
OPERATE_RET tkl_ble_gattc_write_without_rsp(USHORT_T conn_handle, USHORT_T char_handle, UCHAR_T *p_data, USHORT_T length)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gattc_write_without_rsp!\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   [Ble Central] Write Data with response
 * @param   [in] conn_handle    Connection handle.
 * @param   [in] char_handle    Attribute handle.
 *          [in] p_data         Write Values
 *          [in] length         Value Length
 * @return  SUCCESS
 *          ERROR
 * */
OPERATE_RET tkl_ble_gattc_write(USHORT_T conn_handle, USHORT_T char_handle, UCHAR_T *p_data, USHORT_T length)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gattc_write!\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   [Ble Central] Read Data
 * @param   [in] conn_handle    Connection handle.
 * @param   [in] char_handle    Attribute handle.
 * @return  SUCCESS
 *          ERROR
 * */
OPERATE_RET tkl_ble_gattc_read(USHORT_T conn_handle, USHORT_T char_handle)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gattc_read!\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   Start an ATT_MTU exchange by sending an Exchange MTU Request to the server.
 * @param   [in] conn_handle    Connection handle.
 *          [in] client_rx_mtu  mtu size.
 * @return  SUCCESS
 *          ERROR
 * */
OPERATE_RET tkl_ble_gattc_exchange_mtu_request(USHORT_T conn_handle, USHORT_T client_rx_mtu)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_gattc_exchange_mtu_request!\n");
    return OPRT_OK;
    // --- END: user implements ---
}

/**
 * @brief   [Special Command Control] Base on Bluetooth, We can do some special commands for exchanging some informations.
 * @param   [in] opcode         Operations Opcode.
 *          [in] user_data      Post Some Special Commands Data.
 *          [in] data_len       User's Data Length.
 * @note    For Operations Codes, we can do anythings after exchange from TAL Application
 *          And We define some Opcodes as below for reference.
 *          For Bluetooth NCP Module: Mask=0x01, Code ID: 0x00~0xff. Opcode = ((0x01 << 8) & Code ID)
 *          eg:     0x0100: Special Vendor Module Init
 *                  0x0101: Special Vendor Module Deinit
 *                  0x0102: Special Vendor Module Reset
 *                  0x0103: Special Vendor Module Check Exist: Return OPRT_OK or OPRT_NOT_FOUND ..
 *                  0x0104: Specail Vendor Module Version Get.
 *                  0x0105: Specail Vendor Module Version Set.
 *                  0x0106: Specail Vendor Module Version Update.
 *                  0x0107: Specail Vendor Module Scan Switch.
 *                  0x0108: Specail Vendor Module Scan Stop.
 *                  0x0109: Specail Vendor Module Auth Check.
 *                  0x0110: Specail Vendor Module Auth Erase.
 *
 *  * @return  SUCCESS
 *          ERROR
 * */
OPERATE_RET tkl_ble_vendor_command_control(USHORT_T opcode, VOID_T *user_data, USHORT_T data_len)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_vendor_command_control function!\n");

    return OPRT_OK;
    // --- END: user implements ---
}

OPERATE_RET tkl_ble_set_mode(CONST BOOL_T enable, CONST UCHAR_T mode)
{
    // --- BEGIN: user implements ---
	printf("tkl_ble_set_mode function!\n");

    return OPRT_OK;
    // --- END: user implements ---    
}